//+------------------------------------------------------------------+
//|                                    TrC_DelayRingedBar_simple.mq4 |
//|                            Copyright  2005, JimsTradingMachine. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  20050610

extern double Lots               = 0.1;
bool OpenNewTrades               = true;
extern int maxTrades             =2;
extern double MaximumRisk        = 0.02;
extern double takeProfit      = 60;
extern double stopLoss        = 0;             // do not use s/l
extern double DecreaseFactor     = 3;
extern double MovingPeriod       = 12;
extern double MovingShift        = 6;
extern double MovingPeriodSQ     = 21;
extern double MovingPeriodSS     = 14;
extern double MovingPeriodSL     = 30;
extern double MovingShiftS       = 3;
double sto;
double rsi;
double realTP, realSL;
double delayb;                                // Delay Order entry with Stochastics & RSI
double delays;                                // Delay Order entry with Stochastics & RSI
double LastEntryDetectedBuy;                  // most recent Buy Order condition met
double LastEntryDetectedSell;                 // most recent Sell Order condition met
double minAllowedLot, lotStep, maxAllowedLot;
double pips2dbl;
double lots; 
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {  
//----

   Comment("Copyright  2011, Matus German");
   
   if (Digits == 5 || Digits == 3)    // Adjust for five (5) digit brokers.
   {            
      pips2dbl = Point*10;
   } 
   else 
   {    
      pips2dbl = Point;   
   }
   
   realSL = pips2dbl*stopLoss;
   realTP = pips2dbl*takeProfit;
  
   minAllowedLot  =  MarketInfo(Symbol(), MODE_MINLOT);    //IBFX= 0.10
   lotStep        =  MarketInfo(Symbol(), MODE_LOTSTEP);   //IBFX= 0.01
   maxAllowedLot  =  MarketInfo(Symbol(), MODE_MAXLOT );   //IBFX=50.00
   
   if(lots < minAllowedLot)
      lots = minAllowedLot;
   if(lots > maxAllowedLot)
      lots = maxAllowedLot;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ma;
   double mab;
   double maa; 
   double val;
   int    res;
   int cnt=0, total;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   mab=iMA(NULL,0,14,0,MODE_LWMA,PRICE_WEIGHTED,3);
   maa=iMA(NULL,0,21,3,MODE_LWMA,PRICE_WEIGHTED,3);
   val=iForce(NULL, 0, 13,MODE_SMA,PRICE_OPEN,0);
   sto=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   rsi=iRSI(NULL,0,4,PRICE_OPEN,0);
   
   delayb=(sto<20 && rsi<30);
   delays=(sto>80 && rsi>70);
   
   LastEntryDetectedBuy = (Low[4]>Low[3] && Low[3]<Low[2] && Close[1]>High[2] && Close[1]<Open[0] && mab>maa);
   LastEntryDetectedSell = (High[4]<High[3] && High[3]>High[2] && Close[1]<Low[2] && Close[1]>Open[0] && mab<maa); 

//---- sell conditions
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)   
   if(High[4]<High[3] && High[3]>High[2] && Close[1]<Low[2] && Close[1]>Open[0] && mab<maa) 
     {
      static datetime LastEntryDetectedSell; 
      int iBarSe = iBarShift(NULL,0, LastEntryDetectedSell); 
      if (delays == iBarSe)
      return;     
   
      
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,0,0,"",MAGICMA,0,Red);
      return;
      
      if(LotsOptimized()>=maxTrades)
      OpenNewTrades = false;
     }
//---- buy conditions
   if(Low[4]>Low[3] && Low[3]<Low[2] && Close[1]>High[2] && Close[1]<Open[0] && mab>maa)
     {
      static datetime LastEntryDetectedBuy;
      int iBarBu = iBarShift(NULL,0, LastEntryDetectedBuy);
      if (delayb == iBarBu)
      return;     
     
      
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,0,0,"",MAGICMA,0,Blue);
      return;
      
      if(LotsOptimized()>=maxTrades)
      OpenNewTrades = false;
     }
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double ma;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
  
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(Close[0]>=realSL ||  Close[0]>=realTP) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;        
        
         
        }
      if(OrderType()==OP_SELL)
        {
          // should it be closed?        
            if(Close[0]>=realSL ||  Close[0]>=realTP) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;  
        }
     }

  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+